<?php
/* $Id: get_context.php,v 1.5 2003/01/29 19:27:18 sacerdoti Exp $ */
include_once "./conf.php";

$meta_designator = "Grid";
$cluster_designator = "Cluster Overview";

# Blocking malicious CGI input.
$cluster          = escapeshellcmd(rawurldecode($HTTP_GET_VARS["c"]));
$grid           = escapeshellcmd(rawurldecode($HTTP_GET_VARS["G"]));
$host             = escapeshellcmd(rawurldecode($HTTP_GET_VARS["h"]));
$range            = escapeshellcmd(rawurldecode($HTTP_GET_VARS["r"]));
$metric           = escapeshellcmd(rawurldecode($HTTP_GET_VARS["m"]));
$sort             = escapeshellcmd(rawurldecode($HTTP_GET_VARS["s"]));
$controlroom      = escapeshellcmd(rawurldecode($HTTP_GET_VARS["cr"]));
# The 'p' variable specifies the verbosity level in the physical view.
$physical         = escapeshellcmd(rawurldecode($HTTP_GET_VARS["p"]));
# Grid Tree mode.
$tree = escapeshellcmd($HTTP_GET_VARS["t"] );

# A custom range value for job graphs, in -sec.
$jobrange         = escapeshellcmd( $HTTP_GET_VARS["jr"] );
# A red vertical line for various events. Value specifies the event time.
$jobstart         = escapeshellcmd( $HTTP_GET_VARS["js"] );

# The direction we are travelling in the grid tree
$gridwalk = escapeshellcmd($HTTP_GET_VARS["gw"] );
# A stack of grid parents. Prefer a GET variable, default to cookie.
if ($HTTP_GET_VARS["gs"])
   {
      $gridstack = explode(">", rawurldecode($HTTP_GET_VARS["gs"]));
   }
else
   {
      $gridstack = explode(">", $HTTP_COOKIE_VARS["gs"] );
   }

# Assume we are the first grid visited in the tree if there are no CGI variables, 
# or gridstack is not well formed. Gridstack always has at least one element.
if (!count($HTTP_GET_VARS) or !strstr($gridstack[0], "http://"))
   {
      $initgrid=TRUE;
   }


if(!$cluster && !$host && $controlroom)
   {
      $context = "control";
   }
else if ($tree)
   {
      $context = "tree";
   }
else if(!$cluster and !$grid and !$host)
   {
      $context = "meta";
   }
else if($grid)
   {
      $context = "grid";
   }
else if ($cluster and !$host and $physical)
   {
      $context = "physical";
   }
else if($cluster and !$host)
   {
      $context = "cluster";
   }
else if($cluster and $host and $physical)
   {
      $context = "node";
   }
else if($cluster and $host)
   {
      $context = "host";
   }

if (!$range)
   {
      $range = "$default_range";
   }

switch ($range)
{
   case "hour":
      $start = -3600;
      break;
   case "day":
      $start = -86400;
      break;
   case "week":
      $start = -604800;
      break;
   case "month":
      $start = -2419200;
      break;
   case "year":
      $start = -31449600;
      break;
   case "job":
      if ($jobrange) {
        $start = $jobrange;
        break;
     }
   default:
      $start = -3600;
}

if (!$metric)
   {
      $metric = "$default_metric";
   }

if (!$sort)
   {
      $sort = "descending";
   }

# A hack for pre-2.5.0 ganglia data sources.
$always_constant = array(
   "cpu_aidle" => 1,
   "swap_total" => 1,
   "cpu_speed" => 1,
   "swap_total" => 1
);

$always_timestamp = array(
   "gmond_started" => 1,
   "reported" => 1,
   "sys_clock" => 1,
   "boottime" => 1
);

?>
