<?php
/* $Id: header.php,v 1.9 2003/03/07 20:30:47 sacerdoti Exp $ */

// Check if this context is private.
include_once "auth.php";
checkcontrol();
checkprivate();

if ( $context == "control" && $controlroom < 0 ) 
   {
         $header = "header-nobanner";
   }
else 
   {
         $header = "header";
   }
$tpl = new TemplatePower( template("$header.tpl") );
$tpl->prepare();

// Maintain our path through the grid tree.
$me = $self . "@" . $grids[$self][AUTHORITY];

if ($initgrid) 
   {
      $gridstack = array();
      $gridstack[] = $me;
   }
else if ($gridwalk=="fwd")
   {
      // push our info on gridstack, format is "name@url name2@url".
      if (end($gridstack) != $me)
         {
            $gridstack[] = $me;
         }
   }
else if ($gridwalk=="back")
   {
      // pop a single grid off stack.
      if (end($gridstack) != $me)
         {
            array_pop($gridstack);
         }
   }

$Gridstack = join(">", $gridstack);
$GridstackURL = rawurlencode($Gridstack);

if ($initgrid or $gridwalk)
   {
      // Use cookie so we dont have to pass gridstack around within this site.
      // Cookie values are automatically urlencoded. Expires in a day.
      setcookie("gs", $Gridstack, time() + 86400);
   }

// Invariant: back pointer is second-to-last element of gridstack. Grid stack never
// has duplicate entries.
list($parentgrid, $parentlink) = explode("@", $gridstack[count($gridstack)-2]);

// Setup a redirect to a remote server if you choose a grid from pulldown menu. Tell
// destination server that we're walking foward in the grid tree.
if (strstr($cluster, "http://")) 
   {
      $tpl->assign("refresh", "0");
      $tpl->assign("redirect", ";URL=$cluster?gw=fwd&gs=$GridstackURL");
      echo "<h2>Redirecting, please wait...</h2>";
      $tpl->printToScreen();
      exit;
   }
$tpl->assign("refresh", $default_refresh);

/* D h:i:s a */
$tpl->assign( "date", date("r"));
$tpl->assign( "page_title", $title );

// The page to go to when "Get Fresh Data" is pressed.
if (isset($page)) 
   {
      $tpl->assign("page",$page);
   }
else 
   {
      $tpl->assign("page","./");
   }

// Templated Logo image
$tpl->assign("images","./templates/$template_name/images");

//
// Used when making graphs via graph.php. Included in most URLs
//
$sortURL=rawurlencode($sort);
$get_metric_string = "m=$metric&r=$range&s=$sortURL";
if ($jobrange and $jobstart)
        $get_metric_string .= "&jr=$jobrange&js=$jobstart";

// Set the Alternate view link.
$clusterURL=rawurlencode($cluster);
$nodeURL=rawurlencode($host);

if ($context=="cluster")
   {
      $tpl->assign("alt_view", "<a href=\"./?p=2&c=$clusterURL\">Physical View</a>");
      // Enable jobs link for this cluster, if present.
      $tpl->newBlock("jobs");
      $tpl->assign("images","./templates/$template_name/images");
      $tpl->assign("cluster", $clusterURL);
      $tpl->gotoBlock("_ROOT");
   }
elseif ($context=="physical") 
   {
      $tpl->assign("alt_view", "<a href=\"./?c=$clusterURL\">Full View</a>");
   }
elseif ($context=="node") 
   {
      $tpl->assign("alt_view",
      "<a href=\"./?c=$clusterURL&h=$nodeURL&$get_metric_string\">Host View</a>");
   }
elseif ($context=="host") 
   {
      $tpl->assign("alt_view",
      "<a href=\"./?p=2&c=$clusterURL&h=$nodeURL\">Node View</a>");
   }

// Build the node_menu
$node_menu = "";

if ($parentgrid) 
   {
      $node_menu .= "<B><A HREF=\"$parentlink?gw=back&gs=$GridstackURL\">".
         "$parentgrid $meta_designator</A></B> ";
      $node_menu .= "<B>&gt;</B>\n";
   }

# Show grid.
if (!$standalone)
   {
      $node_menu .= "<B><A HREF=\"./?$get_metric_string\">$self $meta_designator</A> ";
      $node_menu .= "<B>&gt;</B>\n";
   }

if ($physical)
   $node_menu .= hiddenvar("p", $physical);

if ( $cluster )
   {
      $url = rawurlencode($cluster);
      $node_menu .= "<B><A HREF=\"./?c=$url&$get_metric_string\">$cluster</A></B> ";
      $node_menu .= "<B>&gt;</B>\n";
      $node_menu .= hiddenvar("c", $cluster);
   }
else
   {
      // No cluster has been specified, so drop in a list
      $node_menu .= "<SELECT NAME=\"c\" OnChange=\"ganglia_form.submit();\">\n";
      $node_menu .= "<OPTION VALUE=\"\">--Choose a Source\n";
      ksort($grids);
      foreach( $grids as $k => $v )
         {
            if ($k==$self) continue;
            $url = $v[AUTHORITY];
            $node_menu .="<OPTION VALUE=\"$url\">$k $meta_designator\n";
         }
      ksort($clusters);
      foreach( $clusters as $k => $v )
         {
            $url = rawurlencode($k);
            $node_menu .="<OPTION VALUE=\"$url\">$k\n";
         }
      $node_menu .= "</SELECT>\n";
   }

if ( $cluster && !$host )
   {
      // Drop in a host list if we have hosts
      if(is_array($hosts) || is_array($hosts_down))
         {
            $node_menu .= "<SELECT NAME=\"h\" OnChange=\"ganglia_form.submit();\">";
            $node_menu .= "<OPTION VALUE=\"\">--Choose a Node\n";
            if(is_array($hosts[$cluster]))
               {
                  ksort($hosts[$cluster]);
                  foreach($hosts[$cluster] as $k=> $v)
                     {
                        $url = rawurlencode($k);
                        $node_menu .= "<OPTION VALUE=\"$url\">$k\n";
                     }
               }
            if(is_array($hosts_down[$cluster]))
               {
                  ksort($hosts[$cluster]);
                  foreach($hosts_down[$cluster] as $k=> $v)
                     {
                        $url = rawurlencode($k);
                        $node_menu .= "<OPTION VALUE=\"$url\">$k\n";
                     }
               }
            $node_menu .= "</SELECT>\n";
         }
      else
         {
            $node_menu .= "<B>No Hosts</B>\n";
         }
   }
else
   {
      $node_menu .= "<B>$host</B>\n";
      $node_menu .= hiddenvar("h", $host);
   }

# Save other CGI variables
$node_menu .= hiddenvar("cr", $controlroom);
$node_menu .= hiddenvar("js", $jobstart);
$node_menu .= hiddenvar("jr", $jobrange);

$tpl->assign("node_menu", $node_menu);


////////////////////// Build the metric menu ////////////////////////////////////

/* Let's get the metrics available for the given context */
if( $context == "meta" || $context == "control" )
   {
      foreach ( $metrics as $c => $foo )
         {
            foreach( $metrics[$c] as $m => $foo )
               {
                  $context_metrics[$m]="";
               }
         }
   }
else if( $context == "cluster" )
   {

     if (!$metrics[$cluster]) {
        echo "<h4>Cannot find any metrics for selected cluster \"$cluster\", exiting.</h4>\n";
        echo "Check ganglia XML tree (telnet $ganglia_ip $ganglia_port)\n";
        exit;
     }
     foreach( $metrics[$cluster] as $m => $foo)
          {
             $context_metrics[$m]="";
          }
   }
else if( $context == "host" )
   {
      // This is uglier but luckily it's not as common
      if(is_array($metrics[$cluster]))
         {
            foreach( $metrics[$cluster] as $m => $h )
               {
                  foreach( $h as $k => $v )
                     {
                        if ($k == $host)
                           {
                              $context_metrics[$m]="";
                           }
                     }

               }
         }
   }

//
// If there are context metrics, show ranges.
//
if (is_array($context_metrics)) {
   $context_ranges[]="hour";
   $context_ranges[]="day";
   $context_ranges[]="week";
   $context_ranges[]="month";
   $context_ranges[]="year";
   if ($jobrange)
      $context_ranges[]="job";

   $range_menu="<B>Last</B>&nbsp;&nbsp;<SELECT NAME=\"r\" OnChange=\"ganglia_form.submit();\">\n";
   foreach ($context_ranges as $v) {
      $url=rawurlencode($v);
      $range_menu .= "<OPTION VALUE=\"$url\" ";
      if ($v == $range) {
         $range_menu .= "SELECTED";
      }
      $range_menu .= ">$v\n";
   }
   $range_menu .= "</SELECT>\n";

   $tpl->assign("range_menu", $range_menu);
}

//
// Only show metric list if we have some and are in cluster context.
//
if (is_array($context_metrics) and ($context == "cluster") )
   {
      $metric_menu = "<B>Metric</B>&nbsp;&nbsp;<SELECT NAME=\"m\" OnChange=\"ganglia_form.submit();\">\n";

      ksort($context_metrics);

      foreach( $context_metrics as $k => $v )
         {
            $url = rawurlencode($k);
            $metric_menu .= "<OPTION VALUE=\"$url\" ";
            if ($k == $metric )
               {
                  $metric_menu .= "SELECTED";
               }
            $metric_menu .= ">$k\n";
         }
      $metric_menu .= "</SELECT>\n";

      $tpl->assign("metric_menu", $metric_menu );      
   }

if ($context == "meta" or $context == "cluster")
   {
      $context_sorts[]="ascending";
      $context_sorts[]="descending";
      $context_sorts[]="by hostname";

      $sort_menu .= "<B>Sorted</B>&nbsp;&nbsp;<SELECT NAME=\"s\" OnChange=\"ganglia_form.submit();\">\n";
      foreach ( $context_sorts as $v )
         { 
            $url = rawurlencode($v);
            $sort_menu .= "<OPTION VALUE=\"$url\" ";
            if ($v == $sort )
               {
                  $sort_menu .= "SELECTED";
               }
            $sort_menu .= ">$v\n";
         }
      $sort_menu .= "</SELECT>\n";

      $tpl->assign("sort_menu", $sort_menu );
   }

// Make sure that no data is cached..
header ("Expires: Mon, 26 Jul 1997 05:00:00 GMT");    // Date in the past
header ("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); // always modified
header ("Cache-Control: no-cache, must-revalidate");  // HTTP/1.1
header ("Pragma: no-cache");                          // HTTP/1.0

$tpl->printToScreen();
?>
